﻿using System;
using System.IO;

namespace GriffinNav.GPS
{
    public class GPSException : ApplicationException
    {
        private string mMessage;
        private string mAssembly;
        private Exception mInnerException;

        public GPSException(Exception ex, string message, string className, string methodName)
        {
            mInnerException = ex;
            mMessage = message;
            mAssembly = string.Concat(className, ".", methodName);
        }

        public override string Message
        {
            get
            {
                return mMessage;
            }
        }

        public string Assembly
        {
            get
            {
                return mAssembly;
            }
        }

        new public Exception InnerException
        {
            get
            {
                return mInnerException;
            }
        }
    }
}