using System;
using System.Collections.Generic;
using System.Text;

namespace GriffinNav.GPS
{
    public class Longitude
    {
        private decimal mCoordinate;
        private LongitudeDirection mDirection;
        private int mDegrees;
        private decimal mMinutes;

        internal Longitude(int degrees, decimal minutes, LongitudeDirection direction)
        {
            mDegrees = degrees;
            mMinutes = minutes;

            Update(degrees, minutes, direction);
        }

        public decimal Coordinate
        {
            get
            {
                return mCoordinate;
            }
        }

        public LongitudeDirection Direction
        {
            get
            {
                return mDirection;
            }
        }

        public int Degrees
        {
            get
            {
                return mDegrees;
            }
        }

        public decimal Minutes
        {
            get
            {
                return mMinutes;
            }
        }

        internal void Update(int degrees, decimal minutes, LongitudeDirection direction)
        {
            mDegrees = degrees;
            mMinutes = minutes;

            // check direction of travel
            if (direction == LongitudeDirection.W) // west
            {
                // convert to negative decimal coordinate
                mCoordinate = 0 - ((decimal)degrees + (minutes / 60M));
            }
            else // east
            {
                // convert to positive decimal coordinate
                mCoordinate = (decimal)degrees + (minutes / 60M);
            }

            mDirection = direction;
        }
    }
}
