using System;
using System.Collections;

namespace GriffinNav.Map
{
    public class MapInfo
    {
        private int[] mDetailLevels;
        private string mMapName;
        private string mFilePath;
        private decimal mCenterLatitude;
        private decimal mCenterLongitude;

        internal MapInfo(string mapName, string mapFilePath, decimal centerLatitude, decimal centerLongitude, int[] detailLevels)
        {
            mMapName = mapName;
            mFilePath = mapFilePath;
            mCenterLatitude = centerLatitude;
            mCenterLongitude = centerLongitude;
            mDetailLevels = detailLevels;
        }

        public string Name
        {
            get
            {
                return mMapName;
            }
        }

        public string FilePath
        {
            get
            {
                return mFilePath;
            }
        }

        public decimal CenterLatitude
        {
            get
            {
                return mCenterLatitude;
            }
        }

        public decimal CenterLongitude
        {
            get
            {
                return mCenterLongitude;
            }
        }

        public int[] DetailLevels
        {
            get
            {
                return mDetailLevels;
            }
        }
    }
}
